package io.zipcoder.interfaces;

public enum Educator implements Teacher {
    KRIS(1, "Kris Younger"),
    NHU(2, "Nhu Nguyen"),
    FROILAN(3, "Froilan Miranda"),
    WILHEM(4, "Wilhem Alcivar"),
    DOLIO(5, "L. Dolio Durant");


    private double timeWorked = 0;
    private long id;
    private String name;

    Educator(long id, String name) {
        this.id = id;
        this.name = name;
    }

    public double getTimeWorked() {
        return timeWorked;
    }

    public long getId() {
        return id;
    }

    public String getName() {
        return name;
    }

    @Override
    public void teach(Learner learner, double numberOfHours) {
        learner.learn(numberOfHours);
        timeWorked += numberOfHours;
    }

    @Override
    public void lecture(Learner[] learners, double numberOfHours) {
        for (Learner learner : learners) {
            learner.learn(numberOfHours/learners.length);
        }
        timeWorked += numberOfHours;
    }
}
