package io.zipcoder.interfaces;

import org.junit.*;

import java.util.Optional;
import java.util.stream.Stream;


public class InstructorTest {
    Instructor instructor;
    Student[] students;

    @Before
    public void setup(){
        instructor = new Instructor(1);
        students = new Student[]{new Student(0),new Student(1),new Student(2)};
    }

    @Test
    public void testImplementation(){
        //When
        boolean actual = instructor instanceof Person;
        //Then
        Assert.assertTrue(actual);
    }
    @Test
    public void testInheritence(){
        //When
        boolean actual = instructor instanceof Teacher;
        //Then
        Assert.assertTrue(actual);
    }

    @Test
    public void testTeach(){
        //Given
        double expected = 1;
        //When
        instructor.teach(students[0], 1);
        double actual = students[0].getTotalStudyTime();
        //Then
        Assert.assertEquals(expected, actual, 0);

    }
    @Test
    public void testLecture(){
        //Given
        Double expected = 6d;
        //When
        instructor.lecture(students,2);
        Double actual = Stream.of(students)
                .map(Student::getTotalStudyTime)
                .reduce((x,y) -> x + y)
                .get()
                ;
        //Then
        Assert.assertEquals(expected, actual, 0);

    }


}
